<ng-container *ngIf="{
         categories: categories$ | async,
         competitions: competitions$ | async,
         divisions: divisions$ | async,
         teams: teams$ | async,
         screenSize: screenSize$ | async } as vm">
  <app-page-form>
    <ng-container ngProjectAs="[page-form-content]">
      <h1>
        {{ 'admin.group.edit.seo.' + mode.toString().toLocaleLowerCase() + '.title' | translate }}
      </h1>
      <p>
        {{ 'admin.group.edit.seo.' + mode.toString().toLocaleLowerCase() + '.description' | translate }}
      </p>
      <form [formGroup]="formGroup"
            #form="ngForm" (ngSubmit)="formGroup.valid && save()">
        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.category' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.category"
                            [control]="formGroup.controls.category"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="category"
                        (selectionChange)="categoryChange()">
              <mat-option *ngFor="let category of vm.categories?.items; trackBy: trackBySlug"
                          [value]="category.slug">
                {{ category.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.category.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.competition' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.competition"
                            [control]="formGroup.controls.competition"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="competition"
                        (selectionChange)="competitionChange()">
              <mat-option *ngFor="let competition of vm.competitions?.items; trackBy: trackBySlug"
                          [value]="competition.slug">
                {{ competition.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.competition.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.division' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.division"
                            [control]="formGroup.controls.division"
                            [updateDisable]="mode !== editModeEnum.UPDATE">
            <mat-select formControlName="division">
              <mat-option *ngFor="let division of vm.divisions?.items; trackBy: trackBySlug"
                          [value]="division.slug">
                {{ division.name }}
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.division.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.name' | translate }}
          </mat-label>
          <input matInput name="name" formControlName="name"/>
          <mat-error *ngIf="formGroup.controls.name.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.index' | translate }}
          </mat-label>
          <input matInput type="number"
                 name="index" formControlName="index"/>
          <mat-error *ngIf="formGroup.controls.index.errors?.unicity">
            {{ 'admin.common.validation.unicity' | translate:{ value: formGroup.controls.index.errors?.unicity?.current } }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.index.errors?.min">
            {{ 'admin.common.validation.min' | translate:{ min: formGroup.controls.index.errors?.min?.min } }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.index.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.teams' | translate }}
          </mat-label>
          <app-async-select [loading]="loading.teams"
                            [control]="formGroup.controls.teams">
            <mat-select formControlName="teams" multiple [compareWith]="compareBySlug">
              <mat-select-trigger class="team">
                <ng-container *ngFor="let team of formGroup.value.teams; trackBy: trackBySlug">
                  <figure *ngIf="'common.team.defaultPicture.url' | translate">
                    <img class="lazy-load"
                         [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                         [errorImage]="'common.team.defaultPicture.url' | translate"
                         [alt]="team.name" />
                    <figcaption>
                      {{ team | teamName:vm.screenSize }}
                      {{ team.index }}
                    </figcaption>
                  </figure>
                </ng-container>
              </mat-select-trigger>
              <mat-option *ngFor="let team of vm.teams?.items; trackBy: trackBySlug"
                          [value]="team" class="team">
                <figure *ngIf="'common.team.defaultPicture.url' | translate">
                  <img class="lazy-load"
                       [lazyLoad]="team.logoUrl || ('common.team.defaultPicture.url' | translate)"
                       [errorImage]="'common.team.defaultPicture.url' | translate"
                       [alt]="team.name" />
                  <figcaption>
                    {{ team | teamName:vm.screenSize }}
                    {{ team.index }}
                  </figcaption>
                </figure>
              </mat-option>
            </mat-select>
          </app-async-select>
          <mat-error *ngIf="formGroup.controls.teams.errors?.required">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.teams.errors?.minLength">
            {{ 'admin.common.validation.required' | translate }}
          </mat-error>
        </mat-form-field>

        <mat-form-field>
          <mat-label>
            {{ 'admin.group.edit.form.dayCount' | translate }}
          </mat-label>
          <input matInput type="number"
                 name="dayCount" formControlName="dayCount"
                 [min]="minDayCount" [max]="maxDayCount"/>
          <mat-error *ngIf="formGroup.controls.dayCount.errors?.max">
            {{ 'admin.common.validation.max' | translate:{ max: formGroup.controls.dayCount.errors?.max?.max } }}
          </mat-error>
          <mat-error *ngIf="formGroup.controls.dayCount.errors?.min">
            {{ 'admin.common.validation.min' | translate:{ min: formGroup.controls.dayCount.errors?.min?.min } }}
          </mat-error>
        </mat-form-field>
      </form>
    </ng-container>
    <ng-container ngProjectAs="[page-form-footer]">
      <a mat-stroked-button color="accent"
         [routerLink]="previousRouteCommands?.commands"
         [queryParams]="previousRouteCommands?.queryParams">
        <mat-icon>
          cancel
        </mat-icon>
        {{ 'admin.common.action.cancel' | translate }}
      </a>
      <app-async-button [loading]="loading.save">
        <button mat-flat-button color="primary" (click)="form.onSubmit($event)">
          <mat-icon>
            save
          </mat-icon>
          {{ 'admin.common.action.save' | translate }}
        </button>
      </app-async-button>
    </ng-container>
  </app-page-form>
</ng-container>
